
!FSReference class methodsFor: '*FilesystemExtensions' stamp: 'sebastiansastre 8/28/2011 17:42'!
on: aString
	"Returns a reference of the path taken from aString"
	
	^ FSFilesystem disk referenceTo: aString! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastiansastre 5/18/2011 15:90'!
absoluteFileName 

	^ self asString! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastian.sastre 8/11/2010 11:10'!
allDirectories
	"Returns all the local subdirectories of this one (if any) 
	plus all the ones in deeper levels."
	
	^ self allChildren ! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastian.sastre 8/11/2010 10:48'!
allFiles
	"Returns all the local subdirectories of this entry (if any)."
	
	^ self allEntries reject:[:e| e isDirectory]! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastiansastre 5/18/2011 15:90'!
asFileDirectory 

	^ self isDirectory
		ifTrue:[FileDirectory on: self asString]
		ifFalse:[nil] ! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastian.sastre 8/11/2010 11:43'!
asPath
	"Convenience to return this very reference to a path."
	^ self! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastian.sastre 8/11/2010 13:58'!
directories
	"Returns all the local subdirectories of this one (if any).
	This is a shallow query (in contraposition to a deep one)"
	
	^ self children select:[:e|
		e isDirectory]! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastian.sastre 8/11/2010 13:54'!
directoryNames
	"Returns a list of names of the local subdirectories."
	
	^ self directories collect:[:e|
		e entry basename]! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastian.sastre 12/8/2010 13:28'!
ensureFile
	"Ensures a file defined by this reference.
	Think of *nix touch command, only it checks for (in)existence."
	| file |

	(self isDirectory or:[
	self exists]) ifTrue:[
		^ self].
	
	[file := (FileDirectory on: self parent asString) newFileNamed: self basename] 
		ensure:[file ifNotNil:[file close]].
		
	! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastian.sastre 11/13/2010 15:46'!
extension 

	^ (self isFile and:[
	(self basename includes: $.)])
		ifTrue:[(self basename reversed readStream upTo: $.) reversed ]
		ifFalse:[String new]! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastian.sastre 8/11/2010 11:52'!
fileName 

	^ self basename ! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastian.sastre 8/11/2010 11:48'!
fileNames
	"Returns a list with the names of the local files."
	
	^ self files collect:[:e|
		e basename]! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastian.sastre 8/11/2010 11:47'!
files
	"Returns all the local files of this directory (if any).
	This is a shallow query (in contraposition to a deep one)"
	
	^ self entries reject:[:e| 
		e isDirectory ]! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastian.sastre 12/8/2010 14:30'!
name 
	"For files, this will answer the name of the file without the extension (if there is one)"
	
	^ (self isFile and:[
	(self basename includes: $.)])
		ifTrue:[(self basename reversed readStream upTo: $. ;upToEnd) reversed ]
		ifFalse:[self basename]! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastian.sastre 9/28/2010 13:53'!
renameAs: aFilename
	"Moves this file to aFilename in this very directory."

	self renameAs: aFilename in: self parent! !

!FSReference methodsFor: '*FilesystemExtensions' stamp: 'sebastian.sastre 9/28/2010 13:52'!
renameAs: aFilename in: aDirectory
	"Moves this file to aDirectory/aFilename.
	For convenience this method will create the path if needed."

	|directory|

	"Makes sure we can put the file there"
	aDirectory exists ifFalse:[
		aDirectory ensureDirectory]. 


	directory := FileDirectory on: aDirectory asString.
	directory 
		primRename: self absoluteFileName 
		to: (aDirectory / aFilename) asString.

! !

!String methodsFor: '*FilesystemExtensions' stamp: 'sebatian.sastre 4/28/2010 17:19'!
asPath

	^ FSReference on: self! !
